﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Input;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace PointSnapToLayer
{
	internal class TsquareEditInteractiveOverlay : EditInteractiveOverlay
	{
		public static Tsquare TSqure = new Tsquare();

		/// <summary>
		/// Переопределяем функцию отрисовки
		/// </summary>
		/// <param name="canvas"></param>
		protected override void DrawTileCore(GeoCanvas canvas)
		{
			if (TSqure.VerticalSlideway != null)
				canvas.DrawLine(new Feature(TSqure.VerticalSlideway), new GeoPen(GeoColor.SimpleColors.Black), DrawingLevel.LevelOne);

			if (TSqure.HorizontalSlideway != null)
				canvas.DrawLine(new Feature(TSqure.HorizontalSlideway), new GeoPen(GeoColor.SimpleColors.Black),
				                DrawingLevel.LevelOne);
			
			base.DrawTileCore(canvas);
		}



		protected override InteractiveResult MouseMoveCore(InteractionArguments interactionArguments)
		{
			if (TSqure.VerticalSlideway == null)
			{
				TSqure.VerticalSlideway = new LineShape(new[]
				                                        	{
				                                        		new Vertex(interactionArguments.WorldX,
				                                        		           interactionArguments.CurrentExtent.
				                                        		           	UpperRightPoint.Y),
				                                        		new Vertex(interactionArguments.WorldX,
				                                        		           interactionArguments.CurrentExtent.
				                                        		           	LowerRightPoint.Y)
				                                        	});
				TSqure.VerticalSlideway.ScaleUp(100);
			}

			if (TSqure.CenterTsquare.CenterPointShape == null)
				TSqure.CenterTsquare.CenterPointShape = new PointShape(interactionArguments.WorldX, interactionArguments.WorldY);

			TSqure.VerticalSlideway = new LineShape(new[]
			                                                {
			                                                    new Vertex(interactionArguments.WorldX,
			                                                               interactionArguments.CurrentExtent.LowerLeftPoint.Y),
			                                                    new Vertex(interactionArguments.WorldX,
			                                                               interactionArguments.CurrentExtent.UpperLeftPoint.Y)
			                                                });
			
			//Draw(interactionArguments.CurrentExtent, OverlayRefreshType.Redraw);
			return base.MouseMoveCore(interactionArguments);
		}

	}
}